'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 23 February 2010 at 6:58:53 pm'!
"Change Set:		SugarScratch-bf
Date:			22 February 2010
Author:			Bert Freudenberg

Make Sugar Journal accessible from Scratch.
Only reading implemented so far.
Toggle preference N to use either Sugar or Scratch UI.
Based on ScratchSource 1.4 release."!

Smalltalk renameClassNamed: #SugarDataStore as: #SugarDatastoreProxy!
DBusCompiledProxy subclass: #SugarDatastoreProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sugar'!

!SugarDatastoreProxy commentStamp: 'bf 2/21/2010 15:18' prior: 0!
This is a DBus proxy for the Sugar Datastore (known to users as "Journal").

SugarDatastoreProxy new
	find: {
		'mime_type'->#('image/png' 'image/jpeg'). 
		'limit' -> 2. 
		'offset' -> 0}
	with: #('title' 'uid')
!
SugarDatastoreProxy class
	instanceVariableNames: ''!
Smalltalk renameClassNamed: #SugarDatastoreDirectory as: #SugarDirectory!
Object subclass: #SugarDirectory
	instanceVariableNames: 'query extension extensions '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sugar'!

!SugarDirectory commentStamp: 'bf 2/22/2010 14:38' prior: 0!
Emulate a FileDirectory by querying the Sugar Datastore (underlying the Sugar Journal). You must provide a list of mime types to filter the datastore, and extensions to map them to.

My filenames are UTF8 strings made from the journal entry's title and appending its 36-character object id, followed by a made-up extension derived from the entry's mime type. A full name prepends 'sugar:/' - this is used in FileStream to dispatch to the Journal reading code.

Example: 'sugar:/some title|fa1536d7-6bef-46f5-932a-d7f6626401ef.png'

(SugarDirectory fileTypes: #(('image/png' 'png') ('image/jpeg' 'jpg'))) fileNames!
SugarDirectory class
	instanceVariableNames: ''!
StandardFileStream subclass: #SugarFileStream
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sugar'!

!SugarFileStream commentStamp: 'bf 2/21/2010 15:33' prior: 0!
I'm just like regular filestream except I will delete the underlying file on close.!
Smalltalk renameClassNamed: #SugarJournal as: #SugarJournalProxy!
DBusCompiledProxy subclass: #SugarJournalProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sugar'!

!SugarJournalProxy commentStamp: 'bf 2/21/2010 15:17' prior: 0!
This is a DBus proxy for the Journal UI. For the underlying storage, see SugarDatastoreProxy.

SugarJournal new chooseObject: 0!
SugarJournalProxy class
	instanceVariableNames: ''!

!FileDirectory methodsFor: 'file name utilities' stamp: 'bf 2/21/2010 18:45'!
displayNameFor: fileName
	^ self class baseNameFor: (self class localNameFor: fileName)! !


!FileStream class methodsFor: 'instance creation' stamp: 'bf 2/21/2010 15:46'!
readOnlyFileNamedOrNil: fileName
	"Attempt to open the file with the given name read-only. If the file does not exist, return nil."

	(fileName beginsWith: SugarDirectory prefix)
		ifTrue: [^ SugarDirectory default readOnlyFileNamed: fileName].

	^ self concreteStream new open: (self fullName: fileName) forWrite: false
! !


!ScratchFileChooserDialog methodsFor: 'initialization' stamp: 'bf 2/22/2010 12:36'!
addShortcutButtons
	"Add shortcut buttons for my type to the shortcutColumn."

	| spacer |
	spacer _ Morph new extent: 5@5; color: Color transparent.
	shortcutColumn removeAllMorphs.

	shortcutColumn addMorphBack: (self shortcutButtonLabel: 'Computer' action: #myComp icon: #folderDiscsIcon).
	shortcutColumn addMorphBack: spacer fullCopy.

	shortcutColumn addMorphBack: (self shortcutButtonLabel: self labelForHomeFolder action: #myHome icon: #folderHouseIcon).
	shortcutColumn addMorphBack: spacer fullCopy.

	shortcutColumn addMorphBack: (self shortcutButtonLabel: 'Desktop' action: #myDesktop icon: #folderIcon).
	shortcutColumn addMorphBack: spacer fullCopy.

	#background = self type ifTrue: [
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'Backgrounds' action: #scratchBackgrounds icon: #folderCatIcon)].

	#costume = self type ifTrue: [
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'Costumes' action: #scratchCostumes icon: #folderCatIcon)].

	#project = self type ifTrue: [
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'Examples' action: #sampleProjects icon: #folderCatIcon).
		shortcutColumn addMorphBack: spacer fullCopy.
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'My Projects' action: #userProjects icon: #folderIcon)].

	#sound = self type ifTrue: [
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'Sounds' action: #scratchSounds icon: #folderCatIcon)].

	self class isSugar ifTrue: [
		shortcutColumn addMorphBack:
			(self shortcutButtonLabel: 'Journal' action: #myJournal icon: #folderIcon)].
! !

!ScratchFileChooserDialog methodsFor: 'shortcuts' stamp: 'bf 2/23/2010 18:53'!
myJournal
	"Sugar Journal button was pressed."
	
	| types extensions directory |
	Preferences useJournalUI ~= Sensor shiftPressed
		ifTrue: [^ self chooseObjectFromJournal].

	types := SugarDirectory defaultFileTypes.

	extensions := list extensions.
	extensions ifNotNil: [
		types := types select: [:each | extensions includes: each second]].

	directory := SugarDirectory fileTypes: types.
	list currentDirectory: directory
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:28'!
chooseObjectFromJournal
	"Invoke the Sugar Journal's object chooser"

	| chooserId types filter extensions media |
	types := SugarDirectory defaultFileTypes.
	filter := ''.

	extensions := list extensions.
	extensions ifNotNil: [
		types := types select: [:each | extensions includes: each second].
		media := (types collect: [:each | each first copyUpTo: $/]) asSet.
		(media size = 1 and: [#('audio' 'image' 'text') includes: media anyOne])
			ifTrue: [filter := media anyOne capitalized]].

	chooserId := self journal chooseObject: 0 filter: filter.
	self registerChooserCallbacks: chooserId.
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:18'!
chooserCancelled
	"The user cancelled the Sugar chooser dialog"

	"If I was deleted when showing the Sugar object chooser, I need to be dismissed properly now. If I am still on screen or the user dismissed me already, do nothing."

	(done not and: [self isInWorld not])
		ifTrue: [self cancelled].
	
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:34'!
chooserResponse: objectId
	"The user selected the Journal entry identified by objectId. Make this dialog return that file."

	list showThumbnails: false. "unnecessary"
	list currentDirectory: (SugarDirectory forSingleObject: objectId).
	list changeSelectionIndexBy: 1. "select the only entry"
	super yes. "bypass"! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:26'!
dbusChooserCancelled: chooserId
	"Sent from DBus mainloop process. The user cancelled the chooser dialog."

	self unregisterChooserCallbacks: chooserId.
	[self chooserCancelled]
		forkAt: Processor userSchedulingPriority.
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:26'!
dbusChooserResponse: chooserId with: objectId
	"Sent from DBus mainloop process. The user selected an object."

	self unregisterChooserCallbacks: chooserId.
	[self chooserResponse: objectId]
		forkAt: Processor userSchedulingPriority.
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/21/2010 19:14'!
journal
	^ SugarJournalProxy new! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:25'!
registerChooserCallbacks: chooserId
	self journal
		onObjectChooserResponse: chooserId send: #dbusChooserResponse:with: to: self;
		onObjectChooserCancelled: chooserId send: #dbusChooserCancelled: to: self.
! !

!ScratchFileChooserDialog methodsFor: 'sugar' stamp: 'bf 2/22/2010 14:26'!
unregisterChooserCallbacks: chooserId
	self journal
		onObjectChooserResponse: chooserId send: nil to: self;
		onObjectChooserCancelled: chooserId send: nil to: self.
! !


!ScratchFileChooserDialog class methodsFor: 'class initialization' stamp: 'bf 2/19/2010 11:43'!
startUp
	self isSugar ifTrue: [DBus startUp: true].
! !

!ScratchFileChooserDialog class methodsFor: 'testing' stamp: 'bf 2/21/2010 19:15'!
isSugar
	^ self sugarActivityId notNil and: [self sugarBundleId notNil]! !

!ScratchFileChooserDialog class methodsFor: 'testing' stamp: 'bf 2/19/2010 14:57'!
sugarActivityId
	"ScratchFileChooserDialog sugarActivityId"
	| i arg |
	Smalltalk platformName = 'unix' ifFalse: [^nil].
	i := -2.
	[	arg _ Smalltalk getSystemAttribute: i.
		arg isEmptyOrNil
	] whileFalse: [
		arg = '-sugarActivityId' ifTrue: [
			arg _ Smalltalk getSystemAttribute: i - 1.
			arg isEmptyOrNil ifFalse: [^arg]].
		i := i - 1].
	^nil	! !

!ScratchFileChooserDialog class methodsFor: 'testing' stamp: 'bf 2/19/2010 14:58'!
sugarBundleId
	"ScratchFileChooserDialog sugarBundleId"
	| i arg |
	Smalltalk platformName = 'unix' ifFalse: [^nil].
	i := -2.
	[	arg _ Smalltalk getSystemAttribute: i.
		arg isEmptyOrNil
	] whileFalse: [
		arg = '-sugarBundleId' ifTrue: [
			arg _ Smalltalk getSystemAttribute: i - 1.
			arg isEmptyOrNil ifFalse: [^arg]].
		i := i - 1].
	^nil	! !


!ScratchFilePicker methodsFor: 'accessing' stamp: 'bf 2/21/2010 16:02'!
extensions
	^ extensions
! !

!ScratchFilePicker methodsFor: 'private' stamp: 'bf 2/21/2010 19:51'!
getDirectoryContents
	"Generate and layout the morphs in my contents pane from the files and folder in the current directory."

	feedbackMorph delete.

	(currentDir isKindOf: FileDirectory)
		ifTrue: [^ self getLocalDirectoryContents].

	(currentDir isKindOf: SugarDirectory)
		ifTrue: [^ self getSugarContents].

	"remote case: start fetching directory contents and give feedback that fetch is started"
	feedbackMorph
		contents: 'Reading from ', currentDir serverName, '...';
		position: self topLeft + (20@60).

	contentsPaneMorph contents removeAllMorphs.
	contentsPaneMorph vScrollRelative: 0.
	self addMorphFront: feedbackMorph.
	fetchInProgress _ true.
! !

!ScratchFilePicker methodsFor: 'private' stamp: 'bf 2/21/2010 18:58'!
getScratchInfoFromSugar
	"Answer the project info dictionary for the currently selected file. Answer the empty dictionary if no file is selected or if the file does not include a project info dictionary (e.g. if it is in an older Scratch file format)."

	| result f version buf |
	result _ Dictionary new.

	self selectedFile ifNil: [^ result].

	[f _ (currentDir readOnlyFileNamed: self selectedFile) binary] ifError: [^ result].

	[
		version _ ObjStream scratchFileVersionFrom: (f next: 10) asString.
		(version = 1) | (version = 2) ifTrue: [
			buf _ f next: f uint32.
			result _ ObjStream new readObjFrom: (ReadStream on: buf)].
	] ifError: [].
	f close.

	^ result
! !

!ScratchFilePicker methodsFor: 'private' stamp: 'bf 2/21/2010 19:51'!
getSugarContents
	"Generate and layout the morphs in my contents pane from the files in the Sugar Journal"

	| fileNames page |
	fileNames _ currentDir fileNames.
	extensions ifNotNil: [  "filter out files without a matching extension"
		fileNames _ fileNames select: [:n |
			extensions includes: (FileDirectory extensionFor: n) asMacRoman asLowercase]].
	fileNames _ fileNames sort: [:n1 :n2 | n1 caseInsensitiveLessOrEqual: n2].

	showThumbnails
		ifTrue: [page _ self thumbnailStylePageFor: fileNames]
		ifFalse: [page _ self listStylePageFor: fileNames].
	contentsPaneMorph contents: page.

	showThumbnails ifTrue: [self startThumbnailFetchProcess].
	self changeSelectionIndexBy: 1.! !

!ScratchFilePicker methodsFor: 'private' stamp: 'bf 2/21/2010 15:11'!
reportScratchProjectInfo
	"Try to retrieve info for the currently selected Scratch project and, if successful, report it to our client."

	| fullPath |
	scratchInfoClient ifNil: [^ self].

	scratchProjectFetcher ifNotNil: [
		scratchProjectFetcher stopDownload.
		scratchProjectFetcher _ nil].

	self selectedFile ifNil: [scratchInfoClient scratchInfo: nil. ^ self].

	(currentDir isKindOf: FileDirectory) ifTrue: [
		^ scratchInfoClient scratchInfo: self getScratchInfoFromFile].

	(currentDir isKindOf: SugarDirectory) ifTrue: [
		^ scratchInfoClient scratchInfo: self getScratchInfoFromSugar].

	"directory is on a server: start a fetcher to get the project info"
	fullPath _ currentDir path, self selectedFile, '.scratch'.
	scratchProjectFetcher ifNil: [scratchProjectFetcher _ HTTPFetcher new].

	((scratchProjectFetcher serverName ~= currentDir serverName) |
	 (scratchProjectFetcher path ~= fullPath)) ifTrue: [
		"start fetching from the new path"
		scratchProjectFetcher
			startDownload: fullPath 
			fromServer: currentDir serverName].

	Delay waitMSecs: 50.
	self checkForScratchInfoFetchDone.
! !


!ScratchFilePickerEntry methodsFor: 'initialization' stamp: 'bf 2/21/2010 18:35'!
name: aString dir: owningDirectory isDirectory: dirFlag

	| icon m n |
	directory _ owningDirectory.
	entryName _ aString.
	entryIsDirectory _ dirFlag.

	entryIsDirectory
		ifTrue: [icon _ ScratchFrameMorph skinAt: #folderIcon]
		ifFalse: [icon _ ScratchFrameMorph skinAt: #fileIcon].

	n _ dirFlag ifTrue: [entryName] ifFalse: [owningDirectory displayNameFor: entryName].
	nameMorph _ StringMorph contents: (UTF8 withAll: n) font: (ScratchFrameMorph getFont: #FilePickerEntry).
	self addMorph: (nameMorph position: self position + (28@3)).

	m _ ImageMorph new form: icon.
	self addMorph: (m position: self position + (6@((nameMorph height - 6) // 2))).

	highlit _ false.
	self extent: 200@(nameMorph height + 6).
! !


!ScratchFilePickerImageEntry methodsFor: 'initialization' stamp: 'bf 2/21/2010 18:35'!
name: aString dir: owningDirectory isDirectory: dirFlag

	| n truncated w eWidth |
	self color: Color transparent.
	self extent: 125@110.

	directory _ owningDirectory.
	entryName _ aString.
	entryIsDirectory _ dirFlag.
	thumbnailReady _ false.

	thumbnailMorph _ ImageMorph new.
	entryIsDirectory
		ifTrue: [thumbnailMorph form: (ScratchFrameMorph skinAt: #bigFolderIcon)]
		ifFalse: [thumbnailMorph form: ((Form extent: 4@4 depth: 8) fillColor: Color transparent)].

	thumbnailMorph top: self bottom - thumbnailMorph height - 23.
	thumbnailMorph left: self left + ((self width - thumbnailMorph width) // 2).

	n _ dirFlag ifTrue: [entryName] ifFalse: [owningDirectory displayNameFor: entryName].
	nameMorph _ StringMorph contents: (UTF8 withAll: n) font: (ScratchFrameMorph getFont: #FilePickerEntry).

	"trim file name to fit button, if necessary"
	truncated _ false.
	eWidth _ (ScratchTranslator stringExtent: '...' font: (ScratchFrameMorph getFont: #FilePickerEntryHighlighted)) x.
	w _ 100 - eWidth.
	[((ScratchTranslator stringExtent: n font: nameMorph font) x) > w] whileTrue: [
		truncated _ true.
		n _ n copyFrom: 1 to: n size - 1].
	truncated ifTrue: [n _ n, '...'].
	nameMorph contents: (UTF8 withAll: n).
	nameMorph bottom: self bottom - 2.
	self isHighlit
		ifTrue: [nameMorph left: self left + ((self width - nameMorph width - eWidth) // 2)]
		ifFalse: [nameMorph left: self left + ((self width - nameMorph width) // 2)].

	self addMorph: nameMorph.
	self addMorph: thumbnailMorph.
! !


!ScratchFrameMorph methodsFor: 'startup' stamp: 'bf 2/19/2010 12:28'!
startup

	| startupFileNames fileName arg presentationMode |
	ScratchFileChooserDialog startUp.
	HostSystemMenus startUp.
	HostSystemMenus menuBarControler reviseHostMenus.
	ScriptableScratchMorph randomInit.
	ScratchTranslator detectRenderPlugin.
	ScratchTranslator importLanguagesList.

	self processSettingsFile.
	self readDefaultNotes.

	self updateProjectName.
	shuffledCostumeNames _ nil.
	author _ ''.
	loginName _ ''.
	loginPassword _ ''.
	justSaved _ true.
	presentationMode _ false.

	startupFileNames _ InputSensor startupFileNames asOrderedCollection.
	2 to: 10 do: [:i |
		arg _ Smalltalk getSystemAttribute: i.
		(arg notNil and: [arg size > 0]) ifTrue: [
			startupFileNames addLast: (ScratchPlugin primShortToLongPath: arg)]].

	startupFileNames do: [:n |
		(n asLowercase = 'presentation') ifTrue: [presentationMode _ true].
		(n asLowercase = 'fullscreen') ifTrue: [TakeOverScreen _ true]].

	TakeOverScreen ifTrue: [
		Smalltalk fullScreenMode: true.
		World restoreDisplay].

	self enterQuarterModeIfSmallScreen.

	fileName _ startupFileNames
		detect: [:fn |
			(fn asLowercase endsWith: '.sb') or: [fn asLowercase endsWith: '.scratch']]
		ifNone: [nil].
	fileName ifNotNil: [
		presentationMode ifTrue: [Display fillColor: Color black].
		self openScratchProjectNamed: fileName.
		presentationMode ifTrue: [self enterPresentationMode; shoutGo].
		^ self].

	viewerPane currentCategory: 'motion'.
	self setDefaultSprite.
	self newScratchProject.

	fileName _ startupFileNames
		detect: [:fn | fn asLowercase endsWith: '.sprite']
		ifNone: [^ self].

	"open a .sprite file"
	workPane submorphs do: [:m | (m isKindOf: ScratchSpriteMorph) ifTrue: [m deleteSprite]].
	self importSpriteOrProject: fileName.
! !

!ScratchFrameMorph methodsFor: 'file read/write' stamp: 'bf 2/21/2010 19:46'!
openScratchProjectNamed: fName
	"Open a Scratch project with the given name."

	| f projData newProj dir fn|
	self closeMediaEditorsAndDialogs ifFalse: [^ self].
	
	fn _ fName.
	f _ FileStream readOnlyFileNamedOrNil: fn.
 	f ifNil: ["try a different encoding, fixes a Firefox bug, -Jens"
		fn _ fName isoLatinToMac asUTF8.
		f _ FileStream readOnlyFileNamedOrNil: fn.
		f ifNil: [^ self inform: 'Could not read' withDetails: fName]].

	[	projData _ f binary contentsOfEntireFile.
		newProj _ self extractProjectFrom: projData.
		projectInfo _ self extractInfoFrom: projData.
	] ifError: [:err :rcvr | ^ self inform: 'Could not read project; file may be damaged' withDetails: '(', err, ')'].

	projectDirectory _ (fn beginsWith: SugarDirectory prefix)
		ifTrue: [SugarDirectory default]
		ifFalse: [dir _ FileDirectory dirPathFor: fn.
			FileDirectory on: dir].
	ScratchFileChooserDialog setLastFolderTo: projectDirectory forType: #project.
	projectName _ projectDirectory displayNameFor: fn.

	self installNewProject: newProj.
	self initializeWatcherPositions.
	viewerPane updateContents.
! !


!ScratchServerDirectory methodsFor: 'accessing' stamp: 'bf 2/21/2010 18:46'!
displayNameFor: fileName
	^ FileDirectory default displayNameFor: fileName! !


!ScriptableScratchMorph methodsFor: 'media' stamp: 'bf 2/21/2010 18:49'!
mediaNameFromFileName: fileName default: defaultName
	"Answer a name for the given media item. If the existing name is '$$squeak$$' then the media was copied via windows drag-and-drop; use the given default name instead."

	| dir result |
	dir := (fileName beginsWith: SugarDirectory prefix)
		ifTrue: [SugarDirectory default]
		ifFalse: [FileDirectory default].
	result _ dir displayNameFor: fileName.
	(result beginsWith: '$$squeak$$') ifTrue: [result _ defaultName].
	result size > 16 ifTrue: [result _ result copyFrom: 1 to: 16].
	^ result
! !


!StandardFileStream class methodsFor: 'file creation' stamp: 'bf 2/21/2010 15:42'!
readOnlyFileNamed: fileName 
	"Open an existing file with the given name for reading."
	"Changed to open a more usefull popup menu.  It now also includes the most likely choices.  jaf"
	| selection dir files choices newName fullName |
	(fileName beginsWith: SugarDirectory prefix)
		ifTrue: [^ SugarDirectory default readOnlyFileNamed: fileName].
	fullName _ self fullName: fileName.
	(self isAFileNamed: fullName)
		ifTrue: [^ self new open: fullName forWrite: false].
	"File does not exist..."
	dir _ FileDirectory forFileName: fullName.
	files _ dir fileNames.
	choices _ (FileDirectory localNameFor: fullName) correctAgainst: files.
	choices add: 'Choose another name'.
	choices add: 'Cancel'.
	selection _ (PopUpMenu labelArray: choices lines: (Array with: 5) )
		startUpWithCaption: (FileDirectory localNameFor: fullName), '
does not exist.'.
	selection < (choices size - 1) ifTrue: [
		newName _ (dir pathName , FileDirectory slash , (choices at: selection))].
	selection = (choices size - 1) ifTrue: [
		newName _ FillInTheBlank 
							request: 'Enter a new file name' 
							initialAnswer: fileName].
	newName = '' ifFalse: [^ self readOnlyFileNamed: (self fullName: newName)].
	^ self error: 'Could not open a file'! !


!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 15:32'!
create: propsDictionary with: filelikeString with: transferOwnershipBoolean
	"Returns aString 's'."
	"Automatically generated"
	^self dbusPerform: 'create' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: propsDictionary signature: 'a{sv}'.
		DBusArgument value: filelikeString signature: 's'.
		DBusArgument value: transferOwnershipBoolean signature: 'b'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 15:30'!
delete: uidString
	"Returns nothing."
	"Automatically generated"
	^self dbusPerform: 'delete' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: uidString signature: 's'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 16:07'!
find: queryDictionary with: propertiesArrayOfStrings
	"Returns anArrayOfDictionaries 'aa{sv}' and anUint32 'u'."
	"Automatically generated"
	^self dbusPerform: 'find' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: queryDictionary signature: 'a{sv}'.
		DBusArgument value: propertiesArrayOfStrings signature: 'as'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 15:30'!
getFilename: uidString
	"Returns aString 's'."
	"Automatically generated"
	^self dbusPerform: 'get_filename' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: uidString signature: 's'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 15:30'!
getProperties: uidString
	"Returns aDictionary 'a{sv}'."
	"Automatically generated"
	^self dbusPerform: 'get_properties' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: uidString signature: 's'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 16:07'!
getUniquevaluesfor: propertynameString with: queryDictionary
	"Returns anArrayOfStrings 'as'."
	"Automatically generated"
	^self dbusPerform: 'get_uniquevaluesfor' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: propertynameString signature: 's'.
		DBusArgument value: queryDictionary signature: 'a{sv}'.}! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 9/18/2008 16:22'!
onCreatedSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'Created'
		interface: 'org.laptop.sugar.DataStore'
		signature: 's'
		send: aSelector to: anObject! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 9/18/2008 16:22'!
onDeletedSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'Deleted'
		interface: 'org.laptop.sugar.DataStore'
		signature: 's'
		send: aSelector to: anObject! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 9/18/2008 16:22'!
onStoppedSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'Stopped'
		interface: 'org.laptop.sugar.DataStore'
		signature: ''
		send: aSelector to: anObject! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 9/18/2008 16:22'!
onUpdatedSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'Updated'
		interface: 'org.laptop.sugar.DataStore'
		signature: 's'
		send: aSelector to: anObject! !

!SugarDatastoreProxy methodsFor: 'org.laptop.sugar.DataStore' stamp: 'bf 3/27/2008 15:30'!
update: uidString with: propsDictionary with: filelikeString with: transferOwnershipBoolean
	"Returns nothing."
	"Automatically generated"
	^self dbusPerform: 'update' interface: 'org.laptop.sugar.DataStore' withArguments: {
		DBusArgument value: uidString signature: 's'.
		DBusArgument value: propsDictionary signature: 'a{sv}'.
		DBusArgument value: filelikeString signature: 's'.
		DBusArgument value: transferOwnershipBoolean signature: 'b'.}! !

!SugarDatastoreProxy methodsFor: 'matching' stamp: 'bf 9/18/2008 16:24'!
onUpdated: objectId send: aSelector to: anObject
	^self onDBusSignal: 'Updated'
		interface: 'org.laptop.sugar.DataStore'
		arguments: {0 -> objectId}
		send: aSelector to: anObject
! !


!SugarDatastoreProxy class methodsFor: 'accessing' stamp: 'bf 3/27/2008 17:28'!
dbusConnection
	^DBus sessionBus! !

!SugarDatastoreProxy class methodsFor: 'accessing' stamp: 'bf 3/3/2008 17:54'!
dbusName
	^'org.laptop.sugar.DataStore'! !

!SugarDatastoreProxy class methodsFor: 'accessing' stamp: 'bf 3/3/2008 17:54'!
dbusPath
	^'/org/laptop/sugar/DataStore'! !


!SugarDirectory methodsFor: 'initialize-release' stamp: 'bf 2/22/2010 13:17'!
query: anArray extensions: aDictionary
	query := anArray.
	extensions := aDictionary.
! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 2/19/2010 14:54'!
datastore
	^ SugarDatastoreProxy new! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 7/24/2007 15:59'!
directory
	"No hierarchies in datastore"
	^''! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 2/21/2010 15:25'!
path
	^ self class prefix! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 2/19/2010 13:39'!
pathName
	^self path! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 7/24/2007 16:58'!
pathParts
	"No hierarchies in datastore"
	^#()! !

!SugarDirectory methodsFor: 'accessing' stamp: 'bf 2/19/2010 13:07'!
serverName
	"a plain language name for this directory"
	^ 'Journal' localized! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:24'!
allNames
	^self fileNames! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:06'!
createDirectory: localName 
	"Create a new sub directory within the current one"
	^ self inform: 'operation not supported' localized! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:06'!
deleteDirectory: localName
	"Delete the sub directory within the current one.  Call needs to ask user to confirm."
	^ self inform: 'operation not supported' localized! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:07'!
deleteFileNamed: localFileName 
	"Delete the file with the given name in this directory."
	^ self inform: 'Use the journal to delete entries' localized! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/22/2010 14:44'!
directoryNamed: aString 
	"Return the subdirectory of this directory with the given name."
	^ self! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/24/2007 16:14'!
directoryNames
	"Return a collection of names for the subdirectories of this directory. "
	^ #()! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/21/2010 18:47'!
displayNameFor: fileName
	"strip object id"
	^ FileDirectory default displayNameFor: (fileName copyUpToLast: $|)! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/22/2010 13:17'!
entries
	"Return a collection of directory entries for the files and 
	directories in this directory."

	| listAndCount title uid mimetype filename |
	listAndCount := self datastore
		find: query
		with: #('uid' 'title' 'mime_type').
	^listAndCount first collect: [:props |
		title := UTF8 withAll: (props at: 'title').
		uid := (props at: 'uid') asString.
		mimetype := (props at: 'mime_type') asString.
		filename := title, '|', uid, '.', (extensions at: mimetype).
		DirectoryEntry fromArray: {filename. 0. 0. false. 0}]! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:17'!
fetchInProgress
	^false! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:17'!
fetchSucceeded
	^true! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/25/2007 19:41'!
fileAndDirectoryNames
	"Return a collection of names for all files and directories in this directory."
	^ self entries collect: [:entry | entry name]! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/25/2007 19:21'!
fileExists: fileName
	^ self fileNames includes: fileName! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/24/2007 16:15'!
fileNames
	"Return a collection of names for the files (but not directories) in this directory."
	^ self entries collect: [:entry | entry name]! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/21/2010 15:11'!
fullNameFor: aString
	^ self path, aString! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/25/2007 19:46'!
includesKey: localName
	"Answer true if this directory includes a file or directory of the given name. Note that the name should be a local file name, in contrast with fileExists:, which takes either local or full-qualified file names."

	^ self fileAndDirectoryNames includes: localName
! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/24/2007 19:18'!
newFileNamed: localName 
	^ self notYetImplemented ! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/24/2007 16:24'!
oldFileNamed: aName
	^ self readOnlyFileNamed: aName! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 7/24/2007 16:24'!
oldFileOrNoneNamed: aName
	^ self readOnlyFileNamed: aName! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/21/2010 16:40'!
parentDirectory
	^ self! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/22/2010 14:44'!
readOnlyFileNamed: aName 
	"aName contains the object id as last 36 chars before the extension"
	| id fileName file |
	id := (aName copyAfterLast: $|) first: 36.
	fileName := self datastore getFilename: id.
	fileName isEmptyOrNil ifTrue: [^nil].
	file := SugarFileStream new open: fileName forWrite: false.
	^ file! !

!SugarDirectory methodsFor: 'file directory' stamp: 'bf 2/19/2010 13:07'!
rename: fullName toBe: newName 
	"Rename a remote file. fullName is just be a fileName, or can 
	be directory path that includes name of the server. newName 
	is just a fileName"
	^ self inform: 'operation not supported' localized! !


!SugarDirectory class methodsFor: 'instance creation' stamp: 'bf 2/21/2010 16:37'!
default
	^ self fileTypes: self defaultFileTypes! !

!SugarDirectory class methodsFor: 'instance creation' stamp: 'bf 2/22/2010 13:19'!
fileTypes: mimetypesAndExtensions
	"mimetypesAndExtensions maps mime-types to file extensions, e.g.
	#(('image/png' 'png') ('image/jpeg' 'jpg'))"

	| extensions |
	extensions := Dictionary new.
	mimetypesAndExtensions do: [:ea | extensions at: ea first put: ea second].
	^ self new
		query: {'mime_type' -> extensions keys asArray}
		extensions: extensions! !

!SugarDirectory class methodsFor: 'instance creation' stamp: 'bf 2/22/2010 14:34'!
forSingleObject: objectId
	"This directory will show only a single entry, matching objectId"

	| props mimetype extension |
	props := [SugarDatastoreProxy new getProperties: objectId] ifError: [Dictionary new].
	mimetype := (props at: 'mime_type' ifAbsent: ['unknown']) asString.
	extension := self extensionForMimetype: mimetype.
	^ self new
		query: {'uid' -> objectId}
		extensions: (Dictionary with: mimetype -> extension)! !

!SugarDirectory class methodsFor: 'accessing' stamp: 'bf 2/22/2010 13:50'!
defaultFileTypes
	"Map mimetypes to extensions"

	^#(
		('application/x-scratch-project' sb)
		('image/png' png)
		('image/jpeg' jpg)
		('image/gif' gif)
		('image/bmp' bmp)
		('audio/basic' au)
		('audio/mpeg' mp3)
		('audio/wav' wav)
		('audio/x-wav' wav)
		('audio/x-aiff' aiff)
		('text/plain' txt)
	)! !

!SugarDirectory class methodsFor: 'accessing' stamp: 'bf 2/22/2010 13:27'!
extensionForMimetype: aString
	self defaultFileTypes do: [:each |
		each first = aString ifTrue: [^ each second]].
	^ '???'! !

!SugarDirectory class methodsFor: 'accessing' stamp: 'bf 2/21/2010 15:24'!
prefix
	"Prefix for a full path name"
	^ 'sugar:/'! !


!SugarFileStream methodsFor: 'open/close' stamp: 'bf 2/22/2010 14:44'!
close
	super close.
	FileDirectory default deleteFileNamed: self name! !


!SugarJournalProxy methodsFor: 'org.laptop.Journal' stamp: 'bf 3/27/2008 15:30'!
chooseObject: parentXidInt32
	"Returns aString 's'."
	"Automatically generated"
	^self dbusPerform: 'ChooseObject' interface: 'org.laptop.Journal' withArguments: {
		DBusArgument value: parentXidInt32 signature: 'i'.}! !

!SugarJournalProxy methodsFor: 'org.laptop.Journal' stamp: 'bf 2/22/2010 12:11'!
chooseObject: parentXidInt32 filter: whatFilterString
	"Returns aString 's'.
	Filter can be empty, a bundle id, or 'Text', 'Image', 'Audio', 'Video', 'Link'.

	The filter argument was added in Sugar 0.83, error handling below falls back to older method without filtering"

	^[ self dbusPerform: 'ChooseObject' interface: 'org.laptop.Journal' withArguments: {
		DBusArgument value: parentXidInt32 signature: 'i'.
		DBusArgument value: whatFilterString signature: 's'.}
	] ifError: [self chooseObject: parentXidInt32]! !

!SugarJournalProxy methodsFor: 'org.laptop.Journal' stamp: 'bf 9/9/2008 13:25'!
onObjectChooserCancelledSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'ObjectChooserCancelled'
		interface: 'org.laptop.Journal'
		signature: 's'
		send: aSelector to: anObject! !

!SugarJournalProxy methodsFor: 'org.laptop.Journal' stamp: 'bf 9/9/2008 13:25'!
onObjectChooserResponseSend: aSelector to: anObject
	"Automatically generated"
	^self onDBusSignal: 'ObjectChooserResponse'
		interface: 'org.laptop.Journal'
		signature: 'ss'
		send: aSelector to: anObject! !

!SugarJournalProxy methodsFor: 'org.laptop.Journal' stamp: 'bf 3/27/2008 15:30'!
showObject: objectIdString
	"Returns nothing."
	"Automatically generated"
	^self dbusPerform: 'ShowObject' interface: 'org.laptop.Journal' withArguments: {
		DBusArgument value: objectIdString signature: 's'.}! !

!SugarJournalProxy methodsFor: 'matching' stamp: 'bf 9/9/2008 14:48'!
onObjectChooserCancelled: chooserId send: aSelector to: anObject
	^self onDBusSignal: 'ObjectChooserCancelled'
		interface: 'org.laptop.Journal'
		arguments: {0 -> chooserId}
		send: aSelector to: anObject! !

!SugarJournalProxy methodsFor: 'matching' stamp: 'bf 9/9/2008 14:48'!
onObjectChooserResponse: chooserId send: aSelector to: anObject
	^self onDBusSignal: 'ObjectChooserResponse'
		interface: 'org.laptop.Journal'
		arguments: {0 -> chooserId}
		send: aSelector to: anObject! !


!SugarJournalProxy class methodsFor: 'accessing' stamp: 'bf 3/27/2008 17:28'!
dbusConnection
	^DBus sessionBus! !

!SugarJournalProxy class methodsFor: 'accessing' stamp: 'bf 3/7/2008 16:57'!
dbusName
	^'org.laptop.Journal'! !

!SugarJournalProxy class methodsFor: 'accessing' stamp: 'bf 3/7/2008 16:53'!
dbusPath
	^'/org/laptop/Journal'! !


!ThumbnailCache methodsFor: 'other' stamp: 'bf 2/21/2010 19:42'!
fullThumbnailPath
	"If indexing Sugar Journal, put cache in home dir"

	| dir |
	dir := (directory isKindOf: SugarDirectory)
		ifTrue: [ScratchFileChooserDialog homeDir]
		ifFalse: [directory].
	^ dir fullNameFor: ThumbnailFileName.
! !

!ThumbnailCache methodsFor: 'other' stamp: 'bf 2/21/2010 19:41'!
readThumbnailFile
	"Attempt to read the thumbnail file in my directory and store the result in dict. If the file doesn't exist or can't be read, make dict be an empty dictionary."

	| fName f buf |
	dict _ Dictionary new.
	fName _  self fullThumbnailPath.
	[	(FileStream isAFileNamed: fName) ifTrue: [
			f _ (FileStream readOnlyFileNamed: fName) binary.
			buf _ f contentsOfEntireFile.
			dict _ ObjStream new readObjFrom: (ReadStream on: buf)].
	] ifError: [].
! !

!ThumbnailCache methodsFor: 'other' stamp: 'bf 2/21/2010 19:41'!
writeThumbnailFile
	"Write dict to the thumbnail file in my directory. Do nothing if the file cannot be written."

	| f fn |
 	fn := self fullThumbnailPath.
	dict size = 0 ifTrue: [  "if no thumbnails and no thumbnails file to delete, do nothing"
		(FileStream isAFileNamed: fn)
			ifFalse: [^ self]].
	[	FileDirectory default deleteFileNamed: fn.  "delete may fail if dir is read-only or is an alias"
		((dict size > 0) or: [FileDirectory default fileExists: fn]) ifTrue: [
			f _ (FileStream fileNamed: fn) binary.
			ObjStream new storeObj: dict on: f.
			f close].
	] ifError: [].
! !

SugarDirectory removeSelector: #acceptsUploads!
SugarDirectory removeSelector: #assureExistence!
SugarDirectory removeSelector: #contentsOfFile:!
SugarDirectory removeSelector: #directories!
SugarDirectory removeSelector: #directoryWrapperClass!
SugarDirectory removeSelector: #downloadUrl!
SugarDirectory removeSelector: #exists!
SugarDirectory removeSelector: #extension!
SugarDirectory removeSelector: #extension:!
SugarDirectory removeSelector: #extensions:!
SugarDirectory removeSelector: #groupName!
SugarDirectory removeSelector: #hasEToyUserList!
SugarDirectory removeSelector: #isProjectSwiki!
SugarDirectory removeSelector: #isRemoteDirectory!
SugarDirectory removeSelector: #isSearchable!
SugarDirectory removeSelector: #moniker!
SugarDirectory removeSelector: #query!
SugarDirectory removeSelector: #query:!
SugarDirectory removeSelector: #realUrl!
SugarDirectory removeSelector: #reset!
SugarDirectory removeSelector: #sleep!
SugarDirectory removeSelector: #wakeUp!
SugarDirectory removeSelector: #writeProject:inFileNamed:fromDirectory:!

!SugarDirectory reorganize!
('initialize-release' query:extensions:)
('accessing' datastore directory path pathName pathParts serverName)
('file directory' allNames createDirectory: deleteDirectory: deleteFileNamed: directoryNamed: directoryNames displayNameFor: entries fetchInProgress fetchSucceeded fileAndDirectoryNames fileExists: fileNames fullNameFor: includesKey: newFileNamed: oldFileNamed: oldFileOrNoneNamed: parentDirectory readOnlyFileNamed: rename:toBe:)
!

SugarDatastoreProxy removeSelector: #completeIndexing!
SugarDatastoreProxy removeSelector: #ids:!
SugarDatastoreProxy removeSelector: #mount:with:!
SugarDatastoreProxy removeSelector: #mounts!
SugarDatastoreProxy removeSelector: #onMountedSend:to:!
SugarDatastoreProxy removeSelector: #onUnmountedSend:to:!
SugarDatastoreProxy removeSelector: #unmount:!
ScratchFileChooserDialog removeSelector: #answerObject:!
ScratchFileChooserDialog removeSelector: #chooserAccepted:object:!
ScratchFileChooserDialog removeSelector: #chooserCancelled:!
ScratchFileChooserDialog removeSelector: #releaseObjectChooser:!
ScratchFileChooserDialog removeSelector: #showObjectChooser!

!ScratchFileChooserDialog reorganize!
('initialization' addShortcutButtons createScratchFileChooserFor:saving: getUserResponse initialize)
('accessing' choosingFolder: createFileChooserLayout: defaultName: extensions: listExtent: redirectSavesToSampleFolder scratchFrame: setDirectory: showThumbnails: type type:)
('interaction' getUserResponseForFolder getUserResponseForNewFile yes)
('shortcuts' labelForHomeFolder myComp myDesktop myHome myJournal sampleProjects scratchBackgrounds scratchCostumes scratchSounds userProjects)
('other' delete scratchInfo:)
('sugar' chooseObjectFromJournal chooserCancelled chooserResponse: dbusChooserCancelled: dbusChooserResponse:with: journal registerChooserCallbacks: unregisterChooserCallbacks:)
!

